/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description:     ROM File System example
 * Filename:        trrombld.h
 * Author:          Treck ROM FS Builder v1.4
 * Date Created:    05/17/04
 *
 * Modification History 
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:33:43CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#ifndef _TRHTML_H_
#define _TRHTML_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Description structure for a ROM File*/
typedef struct tsRomFile
{
    const unsigned char *   romFilePagePtr;
    tt32Bit                 romFilePageOffset;
    tt32Bit                 romFileLen;
    const char *            romFileNamePtr;
}ttRomFile;
typedef const ttRomFile TM_FAR * ttRomFilePtr;

extern const unsigned char TM_CONST_QLF tvRomPage0[];
extern const unsigned char TM_CONST_QLF tvRomPage1[];
extern const unsigned char TM_CONST_QLF tvRomPage2[];
extern const unsigned char TM_CONST_QLF tvRomPage3[];
extern const unsigned char TM_CONST_QLF tvRomPage4[];
extern const unsigned char TM_CONST_QLF tvRomPage5[];

static const ttRomFile TM_CONST_QLF tlRomFile[] = 
{
/*    PagePtr      ,  PageOffset,  FileLen ,  FileName */
    { tvRomPage0   ,  0         ,  2220    ,  "/authconfig.htm"},
    { tvRomPage0   ,  2220      ,  411     ,  "/authtest.htm"},
    { tvRomPage0   ,  2631      ,  306     ,  "/config.htm"},
    { tvRomPage0   ,  2937      ,  65      ,  "/dynamic-1.shtm"},
    { tvRomPage0   ,  3002      ,  70      ,  "/dynamic-2.shtm"},
    { tvRomPage0   ,  3072      ,  293     ,  "/form.htm"},
    { tvRomPage0   ,  3365      ,  21819   ,  "/gif/Treck-Logo.jpg"},
    { tvRomPage1   ,  0         ,  8800    ,  ""},
    { tvRomPage1   ,  8800      ,  20642   ,  "/gif/turbo/turbo-ani.gif"},
    { tvRomPage2   ,  0         ,  13058   ,  ""},
    { tvRomPage2   ,  13058     ,  294     ,  "/index.htm"},
    { tvRomPage2   ,  13352     ,  1608    ,  "/left.htm"},
    { tvRomPage2   ,  14960     ,  1346    ,  "/menu.htm"},
    { tvRomPage2   ,  16306     ,  230     ,  "/nesting-1.shtm"},
    { tvRomPage3   ,  0         ,  152     ,  ""},
    { tvRomPage3   ,  152       ,  230     ,  "/nesting-2.shtm"},
    { tvRomPage3   ,  382       ,  230     ,  "/nesting-3.shtm"},
    { tvRomPage3   ,  612       ,  230     ,  "/nesting-4.shtm"},
    { tvRomPage3   ,  842       ,  21643   ,  "/readme.htm"},
    { tvRomPage4   ,  0         ,  6101    ,  ""},
    { tvRomPage4   ,  6101      ,  148     ,  "/ssibadreturn.shtm"},
    { tvRomPage4   ,  6249      ,  402     ,  "/ssitagtoolong.shtm"},
    { tvRomPage4   ,  6651      ,  26      ,  "/static-1.htm"},
    { tvRomPage4   ,  6677      ,  26      ,  "/static-2.htm"},
    { tvRomPage4   ,  6703      ,  2398    ,  "/testssi.htm"},
    { tvRomPage4   ,  9101      ,  1808    ,  "/testssi.shtm"},
    { tvRomPage4   ,  10909     ,  1331    ,  "/testssi2.shtm"},
    { tvRomPage4   ,  12240     ,  5479    ,  "/treck.gif"},
    { tvRomPage5   ,  0         ,  1335    ,  ""}
};

tt16Bit TM_CONST_QLF tlRomPageSize = 16384;
tt16Bit TM_CONST_QLF tlRomPages    = 6;
tt16Bit TM_CONST_QLF tlRomFiles    = 29;

#ifdef __cplusplus
}
#endif

#endif /* _TRHTML_H_ */

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:35      For: Xilinx-Samsung
 * File Name: trrombld.h    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 35691    Output checksum: 14817
 */
