/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2010
 * Copyright Elmic Systems Japan 1997 - 2010
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: prototype for the testing point functions
 *
 * Filename: trtest.h
 * Author: Bryan Wang
 * Date Created: 11/15/2002
 * $Source: include/trtest.h $
 *
 * Modification History
 * $Revision: 6.0.2.3 $
 * $Date: 2010/09/16 17:50:39CDT $
 * $Author: lfox $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#ifndef _TRTEST_H_

#define _TRTEST_H_


#ifdef __cplusplus
extern "C" {
#endif


#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>

/* ttTestInfo is common to at least trtest.c and txnat.c */
#ifdef TM_LINT
LINT_UNREF_MEMBER_BEGIN
#endif /* TM_LINT */
typedef struct tsTestInfo 
{
/* Current zero copy buffer being used by test application */
    ttUserMessage testBufHandle;

/* Current data buffer */
    char TM_FAR * testDataPtr;

/* Test parameters passed in by user to 'tfTestTreck' */
    struct sockaddr_storage  testIpAddress;
    ttUser32Bit   testFlags;
    ttUser32Bit   testCount;
    int           testType;
    int           testPortNum;
    int           testDataSize; /* User data size */

/* What events have occurred (ie, that we have received callbacks for) */
    int           testEvents;

/* Initial socket for the current test */
    int           testSock;
/* 
 * Socket used for data transfer.  For client tests, this is the same as
 * the initial socket.  For server tests, this is the accepted socket.
 */
    int           testDataSock;
    int           testRecvdBytes;
    int           testEchoBytes;
    int           testSentBytes;

/* Current phase in the FSM */
    unsigned char testPhase;

/* Pad to long word aligned */
    unsigned char testPadding[3];

} ttTestInfo;
#ifdef TM_LINT
LINT_UNREF_MEMBER_END
#endif /* TM_LINT */

typedef ttTestInfo TM_FAR * ttTestInfoPtr;

#ifdef TM_USE_TEST_POINTS










#ifdef TM_USE_CRYPTO_TEST
#if ( defined(TM_USE_SHA256) || defined(TM_USE_SHA384)|| \
      defined(TM_USE_SHA512) || \
     (defined(TM_USE_AESXCBC) && defined(TM_USE_AES))    )
int tfxCryptoHashTest();
#endif /* TM_USE_SHA256||TM_USE_SHA384||TM_USE_SHA512||(AESXCBC && AES) */

#endif /* TM_USE_CRYPTO_TEST */









#endif /* TM_USE_TEST_POINTS */

#ifdef __cplusplus
}
#endif

#endif /* _TRTEST_H_ */

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:35      For: Xilinx-Samsung
 * File Name: trtest.h      File Revision: 6.0.2.3 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 12826    Output checksum: 30311
 */
