/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2006
 * Copyright Elmic Systems Japan 1997 - 2006
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
* Description: trcrypam.c - Mapping of Crypto library functions if they are
*   to be used with an alternative software or hardware implementation
*
* Filename: trcrymap.c
* Author: Tim
* Date Created: 3/27/2006
 * $Source: source/cryptlib/trcrymap.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:35:26CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>
#include <trproto.h>
#include <trglobal.h>

#ifdef TM_USE_MAPPED_CRYLIB

#include <trcrylib.h>
#include <tropnssl.h>
#include <trpki.h> 
#include <trcrymap.h>

/* Common mapped Random Number Generator function */
void tfMapGetRandomBytes    (tt8BitPtr rPtr,
                             int size)
{
    tm_map_get_random_bytes(rPtr, size);
}
#endif /* TM_USE_MAPPED_CRYLIB */

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:39      For: Xilinx-Samsung
 * File Name: trcrymap.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 60333    Output checksum:  7921
 */
