/*
 *  Copyright 2003 by Spectrum Digital Incorporated.
 *  All rights reserved. Property of Spectrum Digital Incorporated.
 *
 * $Source: source/kernel/dsp_bios/dm642evm/evmdm642/evmdm642_eeprom.h $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:37:30CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */
 
/*
 *  ======== evmdm642_eeprom.h ========
 *
 *  Interface for the CAT24WC256 I2C EEPROM on the EVMDM642 board
 */
#ifndef EVMDM642_EEPROM_
#define EVMDM642_EEPROM_

#ifdef __cplusplus
extern "C" {
#endif

#include <csl.h>

/* EEPROM definitions */
#define EVMDM642_EEPROM_SIZE           0x8000
#define EVMDM642_EEPROM_I2CADDR        0x50
 
/* Read data from a range in the EEPROM */
void EVMDM642_EEPROM_read(Uint32 src, Uint32 dst, Uint32 length);

/* Write data to a data range in the EEPROM */
void EVMDM642_EEPROM_write(Uint32 src, Uint32 dst, Uint32 length);

#ifdef __cplusplus
}
#endif

#endif


/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:41      For: Xilinx-Samsung
 * File Name: evmdm642_eeprom.h File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 11277    Output checksum: 21301
 */
