;
; Copyright Notice:
; Copyright Elmic Systems USA Inc. 1997, 1998, 1999, 2000, 2001, 2002.
; No portions or the complete contents of this file may be copied or 
; distributed in any form (including but not limited to printed or electronic
; forms) without the expressed written consent of Elmic Systems USA Inc.
; Copyright laws and International Treaties protect the contents of this
; file. Unauthorized use is prohibited. All rights reserved.
;
; Description: EDOSK2674 startup code
;
; Filename: 2674bus.inc
; Author: Qin Zhang
; Date Created: 4/1/03
; $Source: source/kernel/h8s_none/2674bus.inc $
;
; Modification History
; $Revision: 6.0.2.2 $
; $Date: 2010/01/18 06:37:49CST $
; $Author: odile $
; $ProjectName: /home/mks/proj/tcpip.pj $
; $ProjectRevision: 6.0.1.23 $


;/********************************************************************
; *                                                                  *
; *  FILE          : 2623bus.inc                                     *
; *  PURPOSE       : Bus register definitions for the EVB2623        *
; *                  #included in CSTARTUP.S20                       *
; *  AUTHOR        : D T Hartley                                     *
; *  CREATED       : 19/02/99                                        *
; *                                                                  *
; ********************************************************************/

; 2674bus.inc Bus register definitions for the EDOSK2674
;	Version: 1.00 2674 DGL 8/1/02 -- Ported to 2674 EDOSK

 
BASE	.equ 	H'FFFF0000

ABWCR	.equ 	(BASE + H'FEC0)
ASTCR	.equ	(BASE + H'FEC1)
WTCRAH	.equ	(BASE + H'FEC2)
WTCRAL	.equ	(BASE + H'FEC3)
WTCRBH	.equ	(BASE + H'FEC4)
WTCRBL	.equ	(BASE + H'FEC5)
RDNCR	.equ	(BASE + H'FEC6)
CSACRH	.equ	(BASE + H'FEC8)
CSACRL	.equ	(BASE + H'FEC9)
BROMCRH	.equ	(BASE + H'FECA)
BROMCRL	.equ	(BASE + H'FECB)
BCR		.equ	(BASE + H'FECC)
RAMER	.equ	(BASE + H'FECE)
DRAMCR	.equ	(BASE + H'FED0)
DRACCR	.equ	(BASE + H'FED2)
REFCR	.equ	(BASE + H'FED4)
RTCNT	.equ	(BASE + H'FED6)
RTCOR	.equ	(BASE + H'FED7)


PFCR1	.equ	(BASE + H'FE33)
PADDR	.equ	(BASE + H'FE29)

SMR_2	.equ 	(BASE + H'FF88)
BRR_2	.equ	(BASE + H'FF89)
SCR_2	.equ	(BASE + H'FF8A)
SSR_2	.equ	(BASE + H'FF8C)
SCMR_2	.equ	(BASE + H'FF8E)
SEMR	.equ	(BASE + H'FDA8)

PFCR0	.equ 	(BASE + H'FE32)
PFCR2	.equ	(BASE + H'FE34)
P3DDR	.equ	(BASE + H'FE22)
P3DR	.equ	(BASE + H'FF62)
P3ODR	.equ	(BASE + H'FE3C)
PFDDR	.equ	(BASE + H'FE2E)
PGDDR	.equ	(BASE + H'FE2F)
PHDDR	.equ	(BASE + H'FF74)
P7DDR	.equ	(BASE + H'FE26)
P7DR	.equ	(BASE + H'FF66)

MSTPCR	.equ	(BASE + H'FF40)
