/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: EDOSK2674 startup code
 *
 * Filename: hwsetup.c
 * Author: Qin Zhang
 * Date Created: 4/1/03
 * $Source: source/kernel/h8s_none/hwsetup.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:37:52CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */ 

/***********************************************************************/
/*                                                                     */
/*  FILE        :hwsetup.c                                             */
/*  DATE        :Mon, Mar 24, 2003                                     */
/*  DESCRIPTION :Hardware Setup file                                   */
/*  CPU TYPE    :H8S/2676                                              */
/*                                                                     */
/*  This file is generated by Hitachi Project Generator (Ver.2.1).     */
/*                                                                     */
/***********************************************************************/
                  
#include <machine.h>
#include "2674regs.h"

#define SDRAM_CONTRL   				(*((volatile unsigned char *)(0x00400040)))   

void hardware_setup(void)
{
	ABWCR = 0x80;	//area 7 8-bit access space ??
	ASTCR = 0xFF;   //all areas 3-state access space ??
	WTCRAH = 0x27;  //2program wait states for accessing area 7. 7 for area 6
	WTCRAL = 0x77;  //7 wait states for accessing area 5, 7 for area 4
	WTCRBH = 0x71;  //7 wait states for accessinf area 3, 1 for area 2
	WTCRBL = 0x22;  //2 wait states for accessing area 1 and 0.
	RDNCR = 0x00;   //read strobe signal negated
	CSACRH = 0x80;  
	CSACRL = 0x80;
	BROMCRH = 0xA0;
	BROMCRL = 0xA0;
	MSTPCR = 0x0FF7;
	PFCR0 = 0xFF;
	PFCR1 = 0xFF;
	PFCR2 = 0x0D;
	P3DDR = 0x3a;
	P3DR = 0x00;
	P3ODR = 0x06;
	PADDR = 0xFF;
	PFDDR = 0xFE;
	PGDDR = 0x0F;
	PHDDR = 0x0F;
 
	DRACCR 	|= 0x0000; /* Idle cycle inserted, 0-State Pre-charge,
	                   CAS latency enabled, No wait between RAS and CAS cycles
					   DRACCRL	= 0x00;	 No Clock suspend. */
//rev:001+        

	REFCR	|= 0x0188; /* No wait states between CAS and RAS, REF count on 0/2
					   REFCRL	= 0x88;  Enable refresh control,
					   No waits for CAS-before-RAS refresh cycle,
	                   Self refresh enabled, zero states in the pre charge cycle
	                   immediately after self refreshing. */
	RTCOR	|= 0xFF;   /* Compare refresh count with 0xFF*/

	DRAMCR	|= 0x85B4; //SDRAM mode configurating
	SDRAM_CONTRL = 0;  // Cas Latency = 2, Sequential Burst = 8 words.
	DRAMCR	= 0x84B4;  //Return to SDRAM operating mode

/* set interrupt mode */
	INTCR |= 0x20; // DGL -- Switched to mode 2 interrupts

/* Set interrupt priority */
	IPRA = 0x6000;
	IPRB = 0x0000;	
	IPRC = 0x0000;
	IPRD = 0x0000;
	IPRE = 0x0000;
	IPRF = 0x0000;
	IPRG = 0x0000;
	IPRH = 0x0000;
	IPRI = 0x0000;
	IPRJ = 0x0000;
	IPRK = 0x0000;

/* Set EXR mask */
	set_imask_exr(5);
}


/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:42      For: Xilinx-Samsung
 * File Name: hwsetup.c     File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum:  6981    Output checksum: 24418
 */
