/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: EDOSK2674 startup code
 *
 * Filename: sbrk.c
 * Author: Qin Zhang
 * Date Created: 4/1/03
 * $Source: source/kernel/h8s_none/sbrk.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:37:54CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */ 

/***********************************************************************/
/*                                                                     */
/*  FILE        :sbrk.c                                                */
/*  DATE        :Fri, Apr 11, 2003                                     */
/*  DESCRIPTION :Program of sbrk                                       */
/*  CPU TYPE    :H8S/2673                                              */
/*                                                                     */
/*  This file is generated by Hitachi Project Generator (Ver.2.1).     */
/*                                                                     */
/***********************************************************************/
                  


#include <stdio.h>
#include "sbrk.h"

//const size_t _sbrk_size=		/* Specifies the minimum unit of	*/
								/* the defined heap area			*/ 

static  union  {
		long  dummy ;        /* Dummy for 4-byte boundary          */
		char heap[HEAPSIZE]; /* Declaration of the area managed   */
                             /*                           by sbrk */
 }heap_area ;

static  char  *brk=(char *)&heap_area;/* End address of area assigned     */

/**************************************************************************/
/*     sbrk:Data write							  						  */
/*	    Return value:Start address of the assigned area (Pass)	  		  */
/*	                 -1				    (Failure)	  					  */
/**************************************************************************/
char  *sbrk(size_t size)		   /* Assigned area size	  */
{
      char  *p;

      if(brk+size>heap_area.heap+HEAPSIZE) /* Empty area size		  */
	   return (char *)-1 ;

      p=brk ;				   /* Area assignment		  */
      brk += size ;			   /* End address update	  */
      return p ;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:42      For: Xilinx-Samsung
 * File Name: sbrk.c        File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 53286    Output checksum: 58227
 */
