/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2005
 * Copyright Elmic Systems Japan 1997 - 2005
 * Portions Copyright Stretch Incorporated 2005
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description:
 * ISEF instruction for checksum for Stretch S56XX.
 *
 * Filename: checksum.xc
 * Author: Jared August
 * Date Created: 8/26/2005
 */

#include <stretch.h>
#include "main.h"

#ifdef TM_56XX_USE_ISEF_CSUM
SE_FUNC void checksum (SE_INST CHKSUM16_INIT, 
		       SE_INST CHKSUM16, WR X, WR Y, WR J, WR *Z) {

	int i;
	unsigned sum1, sum2, sum3, sum4; 
	static se_uint<32> acc; 
	se_uint<32> out1; 
	se_uint<16> out2; 

	sum1 = 0; sum2 = 0; sum3 = 0;
	for (i = 0; i < 8; i++) {
	 sum1 += X(i*16 + 15, i*16); 
	 sum2 += Y(i*16 + 15, i*16); 
	 sum3 += J(i*16 + 15, i*16); 
	}
	sum4 = sum1 + sum2 + sum3; 
	acc = CHKSUM16_INIT ? sum4 : (acc + sum4); 
	
	out1 = acc(31, 16) + acc(15, 0); 
	out2 = out1(31, 16) + out1(15, 0); 
	*Z = out2; 
}
#endif /* TM_56XX_USE_ISEF_CSUM */
