/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2005
 * Copyright Elmic Systems Japan 1997 - 2005
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description:
 * Main configuration parameters for Stretch S56XX demo project
 *
 * Filename: main.h
 * Author: Jared August
 * Date Created: 8/26/2005
 * $Source: source/kernel/none/s56xx/main.h $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:38:11CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

/* The number of Ethernet ports to use. The driver is currently written to
 * initialize port 0 first, then port 1, etc., for each time the user calls
 * tfOpenInterface. The driver will return an error if the user attempts to
 * open mroe than TM_56XX_NUM_PORTS Ethernet interfaces */
#define TM_56XX_NUM_PORTS 1

/* Define this to use an Ethernet frame size of 9000 instead of 1518 */
#define TM_56XX_USE_JUMBO_FRAMES

/* Poll for Ethernet events instead of using interrupts. This is more
 * efficient when not using an OS */
#define TM_56XX_POLLED_MODE

/* Put the heap where you want it - SRAM's faster, but it's only 256K */
#define TM_56XX_HEAP_IN_SRAM
//#define TM_56XX_HEAP_IN_SDRAM

/* Use the hardware checksum routine */
#define TM_56XX_USE_ISEF_CSUM

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:42      For: Xilinx-Samsung
 * File Name: main.h        File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 52161    Output checksum:  4580
 */
