/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Support routines for the Tiger 31 DSP development board
 *              Most functions derived from sample/tutorial code included
 *              with Tiger 31.
 *
 * Filename: tiger31.h
 * Author: Jason Schmidlapp
 * Date Created:
 * $Source: source/kernel/none/tic3x/tiger31/ti/tiger31.h $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:38:24CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#ifndef _TIGER31_H_
#define _TIGER31_H_

#ifdef __cplusplus
extern "C" {
#endif

#ifndef BIT
#define BIT(n)  ((1)<<(n))
#endif

/* Interrupt vector table entries. */
extern void (*TINT0)(void);
extern void (*INT3)(void);
    
/* Initializes internal timer #0 */
void T31_timer_init(void);

void T31_enable_interrupts(void);    
void T31_disable_interrupts(void);

int T31_setISR(int vector, void (*c_int)(void));

extern void uartIsr(void);
    
#ifdef __cplusplus
}
#endif

#endif /* #ifndef _TIGER31_H_ */

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:42      For: Xilinx-Samsung
 * File Name: tiger31.h     File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 64073    Output checksum: 26570
 */
