# $Source: source/kernel/threadx/arm/arm7/ghs/demo.ld $
#
# Modification History
# $Revision: 6.0.2.2 $
# $Date: 2010/01/18 06:38:47CST $
# $Author: odile $
# $ProjectName: /home/mks/proj/tcpip.pj $
# $ProjectRevision: 6.0.1.23 $
#
# The following explains what the default Green Hills sections are for:
#
# picbase - base of the text sections, relocatable in -pic mode
# text - text section
# syscall - syscall section, for host I/O under Multi
# fixaddr/fixtype - for PIC/PID fixups
# rodata - read only data
# romdata - the ROM image of .data
# romsdata - the ROM image of .sdata
# secinfo - section information section, used by the start-up code
# pidbase - base of the data sections, relocatable in -pid mode
# sdabase - base of the small data area section pointer
# sbss - small BSS (zeroed data) section
# sdata - small data section
# data - non-zeroed writeable data section
# bss - zeroed data section
# heap - the heap, grows upward
# stack - the stack, grows downward

-sec
{
    .reset      0x0000000 : 
    .picbase    0x10000 :       
    .text   :           
    .comment :
    .intercall :
    .interfunc :
    .syscall    :           
    .fixaddr    :
    .fixtype    :
    .rodata :   
    .romdata    ROM(.data) :
    .romsdata   ROM(.sdata) :
    .secinfo    :           
    .pidbase    align(16) :     
    .sdabase    :       
    .sbss   CLEAR :     
    .sdata      :       
    .data   :       
    .bss    CLEAR :     
    .heap align(16) pad(0x2000) :
    .stack align(16) pad(0x2000) :
    .eventlog align(16) pad(0x10000) :
    .free_mem align(16) pad(0x10000) :
}
