/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * $Source: source/kernel/threadx/motorola/cpu32/ghs/trcpm.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:38:59CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#include <trsocket.h>
#include <trquicc.h>
#include <tx_api.h>

volatile static ttQuicc *tlQuiccPtr;
extern void tfQuiccTimerTickIsr(void);

void tfQuiccSetupTimer()
{
    unsigned long *mbar;
    unsigned long  quiccRegisters;
    unsigned char  timerVector;
    unsigned long  timerLocation;

/* The mbar is ALWAYS at 0x03ff00 on a 68360 */
    mbar=(unsigned long *)0x03ff00UL;
    quiccRegisters=TM_QUICC_MBAR_LOC|0x00000001UL;
    *mbar=quiccRegisters;
    tlQuiccPtr = (ttQuicc *)(quiccRegisters&0xfffffffc);
    tlQuiccPtr->timer_tgcr=0x0000;
    timerVector=TM_QUICC_TMR1_INT | TM_QUICC_CICR_VECT;
    timerLocation = timerVector*4;
/* Install the timer vector */
    tfKernelInstallIsrHandler(tfQuiccTimerTickIsr,timerLocation);
    tlQuiccPtr->intr_cicr=TM_QUICC_CICR_DEFAULT;
    tlQuiccPtr->intr_cipr = 0xffffffffUL;
    tlQuiccPtr->intr_cisr |= TM_QUICC_TMR1_INT_MASK;
    tlQuiccPtr->intr_cimr = TM_QUICC_TMR1_INT_MASK;
    tlQuiccPtr->timer_tmr1=0x031a;
    tlQuiccPtr->timer_tcn1=0x0000;
/* 10 ms tick */
    tlQuiccPtr->timer_trr1=0xF424;
    tlQuiccPtr->timer_ter1=0xFFFF;
/* Start the timer */
    tlQuiccPtr->timer_tgcr=0x0005;
}

void tfQuiccTimerClear()
{
    tlQuiccPtr->timer_ter1=0xFFFF;
    tlQuiccPtr->intr_cisr |= TM_QUICC_TMR1_INT_MASK;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:43      For: Xilinx-Samsung
 * File Name: trcpm.c       File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 34306    Output checksum: 62112
 */
