REM $Source: source/kernel/ucos/intelx86/real/borland/ucos.bat $
REM
REM Modification History
REM $Revision: 6.0.2.2 $
REM $Date: 2010/01/18 06:39:33CST $
REM $Author: odile $
REM $ProjectName: /home/mks/proj/tcpip.pj $
REM $ProjectRevision: 6.0.1.23 $

@echo off
echo .
if "%1"=="LARGE" goto large
if "%1"=="SMALL" goto small
goto usage
:large
echo LARGE model
set model=L
goto cont
:small
echo SMALL model
set model=S
goto cont
:usage
echo Usage:
echo %0 [MODEL]
echo where [MODEL] is one of LARGE or SMALL
goto end
:cont
echo .
echo Deleting all object files
del *.obj
echo .
copy os_cfg.%model% os_cfg.h
copy includes.%model% includes.h
echo .
echo Compiling/Assembling Modules for the x86 in %1 model 
echo .
echo Compile Main uC/OS code               (ucos.c)
call bc%model%86cc ucos  TM_KERNEL_UCOS_X86
echo Compile CPU32 Specific "C" Code       (ix86%model%_c.c)
call bc%model%86cc ix86%model%_c TM_KERNEL_UCOS_X86
echo Assemble CPU32 Specific Assembly Code (ix86%model%_a.asm)
tasm ix86%model%_a.asm 
echo Compile Treck-uC/OS Interface         (trucos.c)
call bc%model%86cc trucos TM_KERNEL_UCOS_X86
echo Compile main() Test Application       (test1.c)
call bc%model%86cc test1 TM_KERNEL_UCOS_X86
echo Compile packet driver                 (trpacket.c)
call bc%model%86cc %trhome%\source\drivers\packet\trpacket TM_KERNEL_UCOS_X86
echo .
echo Compile/Assembly Complete!
echo .
echo Linking to test.exe
tlink /k /f /v /m /s /l c0%model%+ix86%model%_a+ucos+ix86%model%_c+trucos+test1+trpacket,test,test,%trhome%\source\treck+c%model%,
echo Link Complete, now cleaning up objects
del *.obj
del os_cfg.h
del includes.h
echo .
echo * Remember to replace test1.c with your main routine
echo * and link in the rest of your application
echo .
type ucos.err
:end
set model=
