/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * $Source: source/kernel/ucos/intelx86/real/msc60/test2.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:39:40CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */
/*
************************************************************
*                         TEST2.C
*                      uCOS EXAMPLE
************************************************************
*/
#include "INCLUDES.H"
#include <graph.h>
#define          OS_MAX_TASKS    10
#define          STK_SIZE      2048
#define          Q_SIZE          10
OS_TCB           OSTCBTbl[OS_MAX_TASKS];
UWORD            OSIdleTaskStk[STK_SIZE];
UWORD            KeyStk[STK_SIZE];
UWORD            DispStk[STK_SIZE];
UWORD            Task1Stk[STK_SIZE];
UWORD            Task2Stk[STK_SIZE];
UWORD            Task3Stk[STK_SIZE];
OS_SEM           Sem;
OS_MBOX          Mbox;
OS_Q             Q;
void            *QData[Q_SIZE];
UWORD            Ctr1 = 0;
UWORD            Ctr2 = 0;
UBYTE            Min  = 0;
UBYTE            Sec  = 0;
void far         KeyTask(void *data);
void far         DispTask(void *data);
void far         Task1(void *data);
void far         Task2(void *data);
void far         Task3(void *data);
void (interrupt far *OldTickISR)();


void main(void)
{
    OldTickISR = _dos_getvect(0x08);
    _dos_setvect(UCOS, OSCtxSw);
    _dos_setvect(0xF2, OldTickISR);
    OSInit(&OSIdleTaskStk[STK_SIZE], OS_MAX_TASKS);
    OSSemInit(&Sem, 1);
    OSMboxInit(&Mbox, (void *)0);
    OSQInit(&Q, &QData[0], Q_SIZE);
    OSTaskCreate(DispTask, (void *)0, (void *)&DispStk[STK_SIZE],   0);
    OSTaskCreate(KeyTask,  (void *)0, (void *)&KeyStk[STK_SIZE],    1);
    OSTaskCreate(Task1,    (void *)0, (void *)&Task1Stk[STK_SIZE], 10);
    OSTaskCreate(Task2,    (void *)0, (void *)&Task2Stk[STK_SIZE], 20);
    OSTaskCreate(Task3,    (void *)0, (void *)&Task3Stk[STK_SIZE], 30);
    OSStart();
}

void far KeyTask(void *data)
{
    UBYTE i;


    _dos_setvect(0x08, OSTickISR);
    while (1) {
        OSTimeDly(1);
        if (kbhit()) {
            switch (getch()) {
                case '1': OSMboxPost(&Mbox, (void *)1);
                          break;
                case '2': OSQPost(&Q, (void *)1);
                          break;
                case 'x':
                case 'X': _dos_setvect(0x08, OldTickISR);
                          exit(0);
                          break;
            }
        }
    }
}


void far Task1(void *data)
{
    UBYTE err;

    while (1) {
        OSMboxPend(&Mbox, 36, &err);
        OSSemPend(&Sem, 0);
        Ctr1++;
        OSSemPost(&Sem);
    }
}


void far Task2(void *data)
{
    UBYTE err;

    while (1) {
        OSQPend(&Q, 72, &err);
        OSSemPend(&Sem, 0);
        Ctr2++;
        OSSemPost(&Sem);
    }
}


void far Task3(void *data)
{
    while (1) {
        OSTimeDly(18);
        OSSemPend(&Sem, 0);
        Sec++;
        if (Sec > 59) {
            Sec = 0;
            Min++;
        }
        OSSemPost(&Sem);
    }
}

static displayString[80];
void far DispTask(void *data)
{
    UWORD ctr1, ctr2;
    UBYTE min,  sec;

    while (1) {
        OSTimeDly(3);
        OSSemPend(&Sem, 0);
        ctr1 = Ctr1;
        ctr2 = Ctr2;
        min  = Min;
        sec  = Sec;
        OSSemPost(&Sem);
        _clearscreen(_GCLEARSCREEN);        
        tfDosWriteLine("Clock = \0");
        tfDosPrintInt(min,2);
        tfDosWriteLine(":\0");
        tfDosPrintInt(sec,2);
        tfDosWriteLine("  Ctr1 = ");
        tfDosPrintInt(ctr1,4);
        tfDosWriteLine("  Ctr2 = ");
        tfDosPrintInt(ctr2,4);
#if 0
        printf("\nClock = %02d:%02d", min, sec);
        printf("\nCtr1  =  %4d", ctr1);
        printf("\nCtr2  =  %4d", ctr2);
#endif
    }
}

int tfDosPrintInt(int num, int len)
{
    int val1;
    int decLoc;
    int i;
    
    while(len)
    {
        decLoc=1;
        for (i=0; i<len-1; i++)
            decLoc = decLoc*10;
        val1=num/decLoc;
        putch('0'+val1);
        num -= val1*decLoc;
        len--;
    }
}
       

int tfDosWriteLine(char * string)
{
    while(*string)
    {
        putch(*string++);
    }
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:43      For: Xilinx-Samsung
 * File Name: test2.c       File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 55905    Output checksum: 20523
 */
