REM $Source: source/kernel/ucos/motorola/cpu32/sds/ucos.bat $
REM
REM Modification History
REM $Revision: 6.0.2.2 $
REM $Date: 2010/01/18 06:40:25CST $
REM $Author: odile $
REM $ProjectName: /home/mks/proj/tcpip.pj $
REM $ProjectRevision: 6.0.1.23 $

@echo off
del *.map
echo .
echo Compiling/Assembling Modules for the %1 processor
echo .
echo Compile Main uC/OS code               (ucos.c)
call sds360cc ucos TM_%1 
echo Compile CPU32 Specific "C" Code       (ucosC32C.c)
call sds360cc ucosC32C TM_%1
echo Assemble CPU32 Specific Assembly Code (ucosC32A.asm)
as68000 -V %1 -f ucosc32A.asm
echo Compile Treck-uC/OS Interface         (trucos.c)
call sds360cc trucos TM_KERNEL_UCOS_CPU32
echo Compile main() Test Application       (test1.c)
call sds360cc test1 TM_KERNEL_UCOS_CPU32
if "%1"=="68360" goto driver
goto complete
:driver
echo Compile 68360 Driver                  (trquicc.c)
call sds360cc %trhome%\source\drivers\m68360\trquicc TM_KERNEL_UCOS_CPU32
:complete
echo Linking to ucos.out
linker -y -E ucos.err -f ucos.spc -o ucos.out *.o %trhome%\source\treck.lib
echo Link Complete, now cleaning up objects
del *.o
echo .
echo * Please Remember that the file ucos.spc is a sample and
echo * Must be changed to match you hardware
echo *
echo * Also remember to replace test1.c with your main routine
echo * and link in the rest of your application
echo .
type ucos.err
