REM $Source: source/kernel/ucos/motorola/ppc/ddi/ucos.bat $
REM
REM Modification History
REM $Revision: 6.0.2.2 $
REM $Date: 2010/01/18 06:40:46CST $
REM $Author: odile $
REM $ProjectName: /home/mks/proj/tcpip.pj $
REM $ProjectRevision: 6.0.1.23 $

@echo off
del *.map
echo .
echo Compiling/Assembling Modules for the %1 processor
echo .
echo Compile Main uC/OS code             (ucos.c)
call ddi860cc ucos TM_%1 
echo Compile PPC Specific "C" Code       (ucosPPCC.c)
call ddi860cc ucosPPCC TM_%1
echo Assemble PPC Specific Assembly Code (ucosPPCA.s)
dcc -Xnested-interrupts -tPPC860ES -c -@E=ucosPPCA.err ucosPPCA.s
echo Compile Treck-uC/OS Interface       (trucos.c)
call ddi860cc trucos TM_KERNEL_UCOS_PPC_RTASK
echo Compile main() Test Application     (test1.c)
call ddi860cc test1 TM_KERNEL_UCOS_PPC_RTASK
echo Compile Embedded Startup Code       (crt0.s)
dcc -tPPC860ES -c -@E=crt0.err crt0.s
if "%1"=="MPC860" goto driver
goto complete
:driver
echo Compile MPC860 Driver               (trmpc860.c)
call ddi860cc %trhome%\source\drivers\mpc860\trmpc860 TM_KERNEL_UCOS_PPC_RTASK
:complete
echo Linking to ucos.out
dld  crt0.o ucosppca.o ucos.o ucosppcc.o trucos.o test1.o trmpc860.o %trhome%\source\treck.lib ucos.lnk -Xelf -o ucos.out 
echo Link Complete, now cleaning up objects
del *.o
echo .
echo * Please Remember that the file ucos.spc is a sample and
echo * Must be changed to match you hardware
echo *
echo * Also remember to replace test1.c with your main routine
echo * and link in the rest of your application
echo .
type ucos.err
