/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * $Source: source/kernel/ucos/motorola/ppc/ghs/fnames.h $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:40:59CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */
#include <sys/types.h>

#if TEST
#define _X(a)	test_##a
#define _Y(a)	a
#else
#define _X(a)	__##a
#define _Y(a)	a
#endif


#define OPEN	_X(open)
#define CLOSE	_X(close)
#define READ	_X(read)
#define WRITE	_X(write)
#define CREAT	_X(creat)
#define FCNTL	_X(fcntl)
#define SBRK	_X(sbrk)
#define GETPID	_X(getpid)
#define KILL	_X(kill)
#define _EXIT	_X(_exit)
#define ISATTY	_X(isatty)
#define LSEEK	_X(lseek)
#define LINK	_X(link)
#define UNLINK	_X(unlink)
#define ACCESS	_X(access)
#define STAT	_X(stat)
#define FSTAT	_X(fstat)

#define MALLOC	_Y(malloc)
#define FREE	_Y(free)
#define STRCMP	_Y(strcmp)
#define STRDUP	_Y(strdup)
#define EXIT	_Y(exit)
#define SIGNAL	_Y(signal)
#define CLOCK	_Y(clock)
#define TIME	_Y(time)

extern void *MALLOC();
extern void FREE();
extern int STRCMP();
extern char *STRDUP();
void (*SIGNAL(int sig, void (*func)(int))) (int) ;

int OPEN(const char *path, int oflag, ...) ;
int CLOSE(int fildes) ;
int READ(int fildes, char *buf, unsigned nbyte) ;
int WRITE(int fildes, char *buf, unsigned nbyte) ;
int __diab_lib_error(int fildes, char *buf, unsigned nbyte) ;
int CREAT(const char *path, mode_t mode) ;
int FCNTL(int fildes, int cmd, ...) ;
void *SBRK(int incr) ;
pid_t GETPID(void) ;
int KILL(int pid, int sig) ;
void _EXIT(int status) ;
int ISATTY(int fildes) ;
int LSEEK(int fildes, int offset, int whence) ;
int LINK(char *path1, char *path2) ;
int UNLINK(char *path) ;
int ACCESS(const char *path, int amode) ;
int STAT(const char *path, struct stat *buf) ;
int FSTAT(int fildes, struct stat *buf) ;

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:45      For: Xilinx-Samsung
 * File Name: fnames.h      File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 48939    Output checksum: 43026
 */
