/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * $Source: source/kernel/ucos/xscale/iq80310/gnu/led.h $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:41:39CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */
/************************************************************************/
/* File: led.h                                                                                                                  */
/* This header file defines constants for display values and data               */ 
/* structure for conversion                                                                                             */
/************************************************************************/
#ifndef LED_H
#define LED_H

#include <stdio.h>
#include <stdlib.h>

/************************************************************************/
/* See IQ80310 Board Manual for 7-Segment Display Bit Definition                */ 
/* Display values: bit=0 turns on, bit=1 turns off                                              */
/************************************************************************/
#define DISPLAY_0                     0xc0 /* 11000000b Display value 0       */
#define DISPLAY_1                     0xf9 /* 11111001b               1       */
#define DISPLAY_2                     0xa4 /* 10100100b               2       */
#define DISPLAY_3                     0xb0 /* 10110000b               3       */
#define DISPLAY_4                     0x98 /* 10011000b               4       */
#define DISPLAY_5                     0x92 /* 10010010b               5       */
#define DISPLAY_6                     0x82 /* 10000010b               6       */
#define DISPLAY_7                     0x87 /* 10000111b               7       */
#define DISPLAY_8                     0x80 /* 10000000b               8       */
#define DISPLAY_9                     0x98 /* 10011000b               9       */
#define DISPLAY_A                     0x88 /* 10001000b               A       */
#define DISPLAY_B                     0x83 /* 10000011b               B       */
#define DISPLAY_C                     0xa7 /* 10100111b               C       */
#define DISPLAY_D                     0xa1 /* 10100001b               D       */
#define DISPLAY_E                     0x86 /* 10000110b               E       */
#define DISPLAY_F                     0x8e /* 10001110b               F       */
#define DISPLAY__                     0xff /* 11111111b All leds off          */ 
#define DELAY                         100000000           

static int leds[] =
{                       DISPLAY_0 ,
                        DISPLAY_1 ,
                        DISPLAY_2 ,
                        DISPLAY_3 ,
                        DISPLAY_4 ,
                        DISPLAY_5 ,
                        DISPLAY_6 ,
                        DISPLAY_7 ,
                        DISPLAY_8 ,
                        DISPLAY_9 ,
                        DISPLAY_A ,
                        DISPLAY_B ,
                        DISPLAY_C ,
                        DISPLAY_D ,
                        DISPLAY_E ,
                        DISPLAY_F ,
                        DISPLAY__
};

#define DISPLAY_LEFT  (unsigned int *) 0xfe840000       /* Left LED          */
#define DISPLAY_RIGHT (unsigned int *) 0xfe850000       /* Right LED         */

int displayLED(unsigned int,unsigned int);

#endif

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:46      For: Xilinx-Samsung
 * File Name: led.h         File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 27605    Output checksum: 22175
 */
