REM $Source: source/kernel/ucos/xscale/iq80310/gnu/ucos.bat $
REM
REM Modification History
REM $Revision: 6.0.2.2 $
REM $Date: 2010/01/18 06:41:58CST $
REM $Author: odile $
REM $ProjectName: /home/mks/proj/tcpip.pj $
REM $ProjectRevision: 6.0.1.23 $

@echo off

echo .
echo Compiling/Assembling Modules for the %1 processor
echo .
echo Compile Main uC/OS code                (ucos_ii.c)         
call gnuxscc ucos_ii TM_KERNEL_UCOS_XSCALE_RTASK				
echo Compile XScale Specific "C" Code       (os_cpu_c.c)
call gnuxscc os_cpu_c TM_KERNEL_UCOS_XSCALE_RTASK
echo Compile XScale Interrupt Code          (interrupts.c)
call gnuxscc interrupts TM_KERNEL_UCOS_XSCALE_RTASK
echo Compile IQ80310 support code           (iq80310.c)
xscale-elf-gcc -mcpu=xscale -mapcs-frame -O0 -c -g -I %trhome%\include iq80310.c -I . -DTM_KERNEL_UCOS_XSCALE_RTASK -DTM_XSCALE_IQ80310
echo Assemble XScale Specific Assembly Code (os_cpu_a.s)
xscale-elf-gcc -Wa -mapcs-frame -c -g os_cpu_a.s -o os_cpu_a.o
echo Compile Treck-uC/OS Interface          (trucos.c)
call gnuxscc trucos TM_KERNEL_UCOS_XSCALE_RTASK
echo Compile main() Test Application        (test1.c)
call gnuxscc test1 TM_KERNEL_UCOS_XSCALE_RTASK
echo Compile 82559 Driver                   (tr8255x.c)
xscale-elf-gcc -mcpu=xscale -mapcs-frame -O0 -c -g -I %trhome%\include %trhome%\source\drivers\8255x\tr8255x.c -I . -DTM_KERNEL_UCOS_XSCALE_RTASK -DTM_XSCALE_IQ80310
echo Compile PCI Driver                     (pci_serv.c)
call gnuxscc pci_serv TM_INTEL_XSCALE
echo Linking to ucos.out
xscale-elf-gcc -O0 -mapcs-frame -Xlinker -Map -Xlinker ucos.map interrupts.o ucos_ii.o  os_cpu_c.o os_cpu_a.o trucos.o test1.o tr8255x.o pci_serv.o iq80310.o %trhome%\source\treck.lib -specs=iq80310.specs -o ucos.elf
echo Link Complete, now cleaning up objects
del *.o
echo .
echo * Please Remember that the file ucos.spc is a sample and
echo * Must be changed to match you hardware
echo *
echo * Also remember to replace test1.c with your main routine
echo * and link in the rest of your application
echo .
