REM $Source: source/kernel/ucos/xscale/iq80321/gnu/testucos.bat $
REM
REM Modification History
REM $Revision: 6.0.2.2 $
REM $Date: 2010/01/18 06:42:09CST $
REM $Author: odile $
REM $ProjectName: /home/mks/proj/tcpip.pj $
REM $ProjectRevision: 6.0.1.23 $

@echo off
rem 1. run "ucosxs gnu" in trhome\source
rem 2. run "testucos" don't need to run step 1 again 
rem if did't change treck source code
rem goto complete
del *.o
del *.err

echo .
echo Compiling/Assembling Modules for the %1 processor

echo .
echo Compile Main uC/OS code   (ucosii.c)         
call gnuxscc ucosii TM_KERNEL_UCOS_XSCALE_RTASK				

echo Compile XSCALE Specific "C" Code       (os_cpu_c.c)
call gnuxscc os_cpu_c TM_KERNEL_UCOS_XSCALE_RTASK

echo Assemble PPC Specific Assembly Code (os_cpu_a.s)
xscale-elf-gcc  -c -g  os_cpu_a.s

echo Compile Treck-uC/OS Interface       (trucos.c)
call  gnuxscc trucos TM_KERNEL_UCOS_XSCALE_RTASK

echo Compile 82544 Driver               (tr8254x.c)
call xscale-elf-gcc -mapcs-frame -mcpu=xscale -Wall -O1 -c -g -I %trhome%\include %trhome%\source\drivers\8254x\tr8254x.c  -I . -DTM_KERNEL_UCOS_XSCALE_RTASK

echo Compile PCI Driver               (pci80321.c)
call gnuxscc pci80321 TM_KERNEL_UCOS_XSCALE_RTASK

REM we have a clean library in trhome\source, copy here
copy %trhome%\source\treck.lib .

REM add driver information to library
xscale-elf-ar -rc treck.lib *.o 
echo Compile main() Test Application     (test1.c)
REM
REM NOTE: if you want debug information for other files, you need
REM add -g whenever you call xscale-elf-gcc like the following line
REM you need modify xslib.bat and TRECKHOME/treckbin\gnuxscc.bat, 

call xscale-elf-gcc -mapcs-frame -mcpu=xscale -O0 -c -g -I %trhome%\include -I . test1.c -DTM_KERNEL_UCOS_XSCALE_RTASK

:complete
xscale-elf-gcc -mapcs-frame -O1 *.o treck.lib -specs=RedBoot.specs -o test1.elf 
rem xscale-elf-objdump -S test1ucos.elf > test1.dis
rem xscale-elf-ld	test1ucos.elf -Map test1.map	
del *.o
echo Link Complete! 

xscale-elf-gdb test1.elf

