/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: BSD Sockets Interface (tfBlockingState)
 *
 * Filename: trblckst.c
 * Author: Paul & Odile
 * Date Created: 11/10/97
 * $Source: source/sockapi/trblckst.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:42:45CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>
#include <trproto.h>

/*
 * Set the socket as blocking or nonblocking 
 */
int tfBlockingState(int socketDescriptor, int blockingState)
{
    int              errorCode;
    ttSocketEntryPtr socketEntryPtr;

    errorCode = TM_ENOERROR;

/* PARAMETER CHECK */
    socketEntryPtr = tfSocketCheckValidLock(  socketDescriptor
                                            );
    if (socketEntryPtr != TM_SOCKET_ENTRY_NULL_PTR)
    {
        if (blockingState == TM_BLOCKING_OFF)
        {
            socketEntryPtr->socFlags |= TM_SOCF_NONBLOCKING;
        }
        else
        {
            if (blockingState == TM_BLOCKING_ON)
            {
                socketEntryPtr->socFlags &= ~TM_SOCF_NONBLOCKING;
            }
            else
            {
                errorCode = TM_EINVAL;
            }
        }
    }
    else
    {
        {
            errorCode = TM_EBADF;
        }
    }
    return tfSocketReturn(socketEntryPtr, socketDescriptor,
                          errorCode, TM_ENOERROR);
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:46      For: Xilinx-Samsung
 * File Name: trblckst.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 35041    Output checksum: 48668
 */
