/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Modified BSD Sockets Interface (bind), without checking to
 *              verify it is a valid address
 *
 * Filename: trbndnck.c
 * Author: Paul, Odile, and Jared
 * Date Created: 11/10/97
 * $Source: source/sockapi/trbndnck.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:42:46CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>
#include <trproto.h>

/*
 * Bind the socket to a port number (without it we are using the random
 * port number), and to an IP address. Unlike the standard bind() call, this
 * function does not check to see if the user is binding to a valid IP
 * Address. This allows the user to send out packets from whatever IP address
 * is desired.
 */
int tfBindNoCheck(int                            socketDescriptor,
                  const struct sockaddr TM_FAR * localAddressPtr,
                  int                            localAddressLength)
{
    return tfBindFlag( socketDescriptor,
                       localAddressPtr,
                       localAddressLength,
                       1 );
}


/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:46      For: Xilinx-Samsung
 * File Name: trbndnck.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 41477    Output checksum: 14502
 */
