/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: tfFlushRecvQ API 
 * Filename: trflushr.c
 * Author: Odile
 * Date Created: 02/19/02
 * $Source: source/sockapi/trflushr.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:43:07CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>
#include <trproto.h>



/* 
 * User call to flush the socket receive queue. 
 */
int tfFlushRecvQ(int socketDescriptor)
{
    ttSocketEntryPtr    socketEntryPtr;
    ttPacketPtr         packetPtr;
    int                 errorCode;

    errorCode = TM_ENOERROR;
/* Parameter check */
    socketEntryPtr = tfSocketCheckValidLock(  socketDescriptor
                                           );

    if (socketEntryPtr != TM_SOCKET_ENTRY_NULL_PTR)
    {
/* Remove queue of packets from the receive queue */
        packetPtr = socketEntryPtr->socReceiveQueueNextPtr;
        socketEntryPtr->socReceiveQueueNextPtr = TM_PACKET_NULL_PTR;
        socketEntryPtr->socReceiveQueueLastPtr = TM_PACKET_NULL_PTR;
        socketEntryPtr->socRecvQueueBytes = 0;
        socketEntryPtr->socRecvQueueDgrams = TM_16BIT_ZERO;
/* Free all the packets in the receive queue */
        tfFreeChainPacket(packetPtr, TM_SOCKET_LOCKED);
    }
    return tfSocketReturn(socketEntryPtr, socketDescriptor,
                          errorCode, TM_ENOERROR);
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trflushr.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 56226    Output checksum: 40518
 */
