/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: BSD Sockets Interface (tfResetConnection)
 *
 * Filename: trrstcon.c
 * Author: Paul & Odile
 * Date Created: 11/10/97
 * $Source: source/sockapi/trrstcon.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:44:08CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>
#include <trproto.h>


/* To Abort the TCP Connection */
int tfResetConnection(int socketDescriptor)
{
    ttSocketEntryPtr socketEntryPtr;
    int              errorCode;
    int              retCode;

    socketEntryPtr = tfSocketCheckValidLock(  socketDescriptor
                                           );
    {
        if (socketEntryPtr != TM_SOCKET_ENTRY_NULL_PTR)
        {
#ifdef TM_USE_TCP
            if (socketEntryPtr->socProtocolNumber == (tt8Bit)IP_PROTOTCP)
            {
                errorCode = TM_ENOERROR;
                (void)tfTcpAbort((ttTcpVectPtr)socketEntryPtr, TM_ECONNABORTED);
            }
            else
#endif /* TM_USE_TCP */
            {
                errorCode = TM_EOPNOTSUPP;
            }
        }
        else
        {
            errorCode = TM_EBADF;
        }
        retCode = tfSocketReturn(socketEntryPtr, socketDescriptor,
                                 errorCode, TM_ENOERROR);
    }
    return retCode;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trrstcon.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 50802    Output checksum: 33453
 */
