/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: BSD Sockets Interface (tfSetIfMtu)
 *
 * Filename: trsetmtu.c
 * Author: Paul & Odile
 * Date Created: 11/10/97
 * $Source: source/sockapi/trsetmtu.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:44:21CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>
#include <trproto.h>
#ifdef TM_LOCK_NEEDED
#include <trglobal.h>
#endif /* TM_LOCK_NEEDED */

/* 
 * Set the MTU for an interface 
 */
int tfSetIfMtu (ttUserInterface interfaceId, int ifMtu)
{
    int     errorCode;
    tt16Bit af;

    if (ifMtu >= TM_IP_MIN_MTU)
    {
        errorCode = tfValidInterface((ttDeviceEntryPtr)interfaceId);
        if (errorCode == TM_ENOERROR)
        {
            af = TM_16BIT_ZERO;
            tm_call_lock_wait(
                        &(((ttDeviceEntryPtr)interfaceId)->devLockEntry));
            ((ttDeviceEntryPtr)interfaceId)->devMtu=(tt16Bit)ifMtu;
            af = (tt16Bit)AF_INET;
            tm_call_unlock(
                        &(((ttDeviceEntryPtr)interfaceId)->devLockEntry));
            {
                tfRtUpdateDevMtu((ttDeviceEntryPtr)interfaceId,
                                 (tt16Bit)ifMtu, af);
            }
        }
    }
    else
    {
        errorCode = TM_EINVAL;
    }
    return(errorCode);
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trsetmtu.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 31607    Output checksum:  7723
 */
