/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Treck "C" strchr library function
 *
 * Filename: trstrchr.c
 * Author: Odile
 * Date Created: 02/19/99
 * $Source: source/sockapi/trstrchr.c $
 *
 * Modification History
 * $Revision: 6.0.2.3 $
 * $Date: 2010/07/30 13:53:12CDT $
 * $Author: pcarney $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>

/* 
 * Return pointer to first instance of character inside string. If no match
 * return NULL.
 */
char TM_FAR * tfStrChr(const char TM_FAR * stringPtr, int character)
{
    char     TM_FAR * retStringPtr;

    retStringPtr = (char TM_FAR *)0;

    if (stringPtr != (const char TM_FAR *)0)
    {
        while (*stringPtr != '\0')
        {
            if (*stringPtr == (char)character)
            {
                retStringPtr = (char TM_FAR *)stringPtr;
                break;
            }
            stringPtr++;
        }
        if ((char)character == '\0')
        {
            retStringPtr = (char TM_FAR *)stringPtr;
        }
    }

    return retStringPtr;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trstrchr.c    File Revision: 6.0.2.3 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum:  3046    Output checksum: 32131
 */
