/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Treck strcpy "C" library function
 *
 * Filename: trstrcpy.c
 * Author: Odile
 * Date Created: 2/10/99
 * $Source: source/sockapi/trstrcpy.c $
 *
 * Modification History
 * $Revision: 6.0.2.4 $
 * $Date: 2011/01/17 13:43:00CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>
#include <trproto.h>

/*
 * Copy from one string to another
 * Does not need to be fast since it is so rarely called
 */

void tfStrCpy(char TM_FAR * destination, const char TM_FAR * source)
{
    if (    (destination != (char TM_FAR *)0)
         && (source != (const char TM_FAR *)0) )
    {
        do
        {
            *destination++ = *source++;
        }
        while (source[-1] != (char)0);
    }
    return;
}

/*
 * Duplicate a string
 */

char * tfStrDup(const char TM_FAR * source)
{
    char * newString;

    newString = (char *)0;
    if (source != (const char TM_FAR *)0)
    {
        newString = (char *)tm_malloc(sizeof(char) * (tm_strlen(source)+1));
        if (newString != (char *)0)
        {
            tm_strcpy(newString, source);
        }
    }

    return newString;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trstrcpy.c    File Revision: 6.0.2.4 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum:  8067    Output checksum: 35096
 */
