/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Treck strcspn "C" library function
 *
 * Filename: trstrcsp.c
 * Author: Odile
 * Date Created: 02/19/99
 * $Source: source/sockapi/trstrcsp.c $
 *
 * Modification History
 * $Revision: 6.0.2.3 $
 * $Date: 2010/12/08 15:05:03CST $
 * $Author: pcarney $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>

/*
 * Return the length of the initial segment of bufferString that consists
 * entirely of characters not included in string.
 */
unsigned int tfStrCSpn( const char TM_FAR * bufferStringPtr,
                        const char TM_FAR * stringPtr )
{
    unsigned int    stringLength;
    unsigned int    retCode;
    char *          strchrResult;

/* tfStrLen checks for null pointer */
    stringLength = (unsigned int) tm_strlen(bufferStringPtr);
    for (retCode = 0; retCode < stringLength; retCode++)
    {
        strchrResult = tfStrChr(stringPtr, bufferStringPtr[retCode]);
        if (strchrResult != (char TM_FAR *)0)
        {
            break;
        }
    }

    return retCode;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trstrcsp.c    File Revision: 6.0.2.3 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 45806    Output checksum: 21077
 */
