/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Treck strrchr "C" library function
 *
 * Filename: trstrrch.c
 * Author: Odile
 * Date Created: 02/19/99
 * $Source: source/sockapi/trstrrch.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:44:48CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>

/* 
 * Return pointer to last instance of character inside string. If no match
 * return NULL.
 */
char TM_FAR * tfStrRChr(const char TM_FAR * stringPtr, int character)
{
    char     TM_FAR * retStringPtr;
    int               i;

    retStringPtr = (char TM_FAR *)0;
    i = (int)(tm_strlen(stringPtr) - 1);
    while (i >= 0)
    {
        if (stringPtr[i] == (char)character)
        {
            retStringPtr = (char TM_FAR *)&stringPtr[i];
            break;
        }
        i--;
    }
    return retStringPtr;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trstrrch.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 37382    Output checksum:  2208
 */
