/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Treck strstr "C" library function
 *
 * Filename: trstrstr.c
 * Author: Odile
 * Date Created: 02/18/99
 * $Source: source/sockapi/trstrstr.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:44:49CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */


/*
 * Include
 */
#include <trsocket.h>
#include <trmacro.h>
#include <trtype.h>

/* 
 * Find a match of string inside bufferstring.
 */
char TM_FAR * tfStrStr( const char TM_FAR * bufferStringPtr,
                        const char TM_FAR * stringPtr )
{
    char TM_FAR * retStringPtr;
    int           stringLength;
    int           bufferStringLength;
    int           retCode;
    int           i;

    retStringPtr = (char TM_FAR *)0;
/* tfStrLen checks for null pointer */
    stringLength = (int)tm_strlen(stringPtr);
    bufferStringLength = (int)tm_strlen(bufferStringPtr);
    if (stringLength > 0)
    {
        i = 0;
        while ( bufferStringLength >= stringLength )
        {
            retCode = tm_memcmp( &bufferStringPtr[i],
                                 stringPtr,
                                 stringLength );
            if (retCode == TM_STRCMP_EQUAL)
            {
                retStringPtr = (char TM_FAR *)&bufferStringPtr[i];
                break;
            }
            i++;
            bufferStringLength--;
        }
    }
    return retStringPtr;
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:47      For: Xilinx-Samsung
 * File Name: trstrstr.c    File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum:  5184    Output checksum: 41637
 */
