/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: Treck file system stub file.  This file is to be used as a 
 *              starting point for integrating a file system.
 *
 * Filename: trfs.c
 * Author: Bryan Wang
 * Date Created: 09/25/03
 * $Source: source/trfs.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:47:24CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#include <trsocket.h>
#include <trmacro.h>

#ifdef TM_USE_TR_FS

#include <trtype.h>
#include <trproto.h>
#include <trglobal.h>


int tfFSChangeDir(
    void TM_FAR * userDataPtr,
    const char TM_FAR * pathNamePtr )
{
    TM_UNREF_IN_ARG(userDataPtr);
    TM_UNREF_IN_ARG(pathNamePtr);

    return -1;
}

int tfFSChangeParentDir(
    void TM_FAR * userDataPtr )
{
    TM_UNREF_IN_ARG(userDataPtr);
    
    return -1;
}

void tfFSCloseDir( 
    void TM_FAR * userDataPtr,
    void TM_FAR * dirDataPtr )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (dirDataPtr);
    
    return;
}

int tfFSCloseFile( 
    void TM_FAR * userDataPtr,
    void TM_FAR * fileDataPtr )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (fileDataPtr);
    
    return -1;
}

int tfFSDeleteFile(
    const void TM_FAR * userDataPtr,
    const char TM_FAR * pathNamePtr )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (pathNamePtr);
    
    return -1;
}

int tfFSFlushFile( 
    void TM_FAR * userDataPtr,
    void TM_FAR * fileDataPtr )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (fileDataPtr);
    
    return -1;
}

int tfFSGetNextDirEntry( 
    void TM_FAR * userDataPtr,
    void TM_FAR * dirDataPtr,
    char TM_FAR * bufferPtr,
    int           maxBytes )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (dirDataPtr);
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (maxBytes);
    
    return -1;
}

int tfFSGetUniqueFileName( 
    void TM_FAR * userDataPtr,
    char TM_FAR * bufferPtr,
    int           bufferSize )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (bufferSize);
    
    return -1;
}

int tfFSGetWorkingDir(
    const void TM_FAR * userDataPtr,
    char TM_FAR * bufferPtr,
    int           bufferSize )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (bufferSize);
    
    return -1;
}

int tfFSMakeDir(
    const void TM_FAR * userDataPtr,
    const char TM_FAR * pathNamePtr,
    char TM_FAR * bufferPtr,
    int           bufferSize )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (pathNamePtr);
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (bufferSize);
    
    return -1;
}

void TM_FAR * tfFSOpenDir(
    void TM_FAR * userDataPtr,
    const char TM_FAR * pathNamePtr,
    int           flag )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (pathNamePtr);
    TM_UNREF_IN_ARG (flag);
    
    return (void TM_FAR *)0;
}

void TM_FAR * tfFSOpenFile(
    const void TM_FAR * userDataPtr,
    const char TM_FAR * pathNamePtr,
    int           flag,
    int           type,
    int           structure)
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (pathNamePtr);
    TM_UNREF_IN_ARG (flag);
    TM_UNREF_IN_ARG (type);
    TM_UNREF_IN_ARG (structure);

    return (void TM_FAR *)0;
}

int tfFSReadFile( 
    void TM_FAR * userDataPtr,
    void TM_FAR * fileDataPtr,
    char TM_FAR * bufferPtr,
    int           bytes )
{
    TM_UNREF_IN_ARG(userDataPtr);
    TM_UNREF_IN_ARG(fileDataPtr);
    TM_UNREF_IN_ARG(bufferPtr);
    TM_UNREF_IN_ARG(bytes);

    return -1;
}

int tfFSReadFileRecord( 
    void TM_FAR * userDataPtr,
    void TM_FAR * fileDataPtr,
    char TM_FAR * bufferPtr,
    int           bytes,
    int  TM_FAR * eorPtr )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (fileDataPtr);
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (bytes);
    TM_UNREF_IN_ARG (eorPtr);

    return -1;
}

int fFSRemoveDir(
    void TM_FAR * userDataPtr,
    char TM_FAR * pathNamePtr)
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (pathNamePtr);
    
    return -1;
}

int tfFSRenameFile(
    const void TM_FAR * userDataPtr,
    const char TM_FAR * fromPathNamePtr,
    const char TM_FAR * toPathNamePtr)
{
    TM_UNREF_IN_ARG(userDataPtr);   
    TM_UNREF_IN_ARG(fromPathNamePtr);   
    TM_UNREF_IN_ARG(toPathNamePtr);   

    return -1;
}

int tfFSStructureMount(
    void TM_FAR * userDataPtr,
    const char TM_FAR * pathNamePtr)
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (pathNamePtr);
    
    return -1;
}

int tfFSSystem(
    char TM_FAR * bufferPtr,
    int           bufferSize)
{
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (bufferSize);
    
    return -1;
}

int tfFSUserAllowed(
    const char TM_FAR * userNamePtr)
{
    TM_UNREF_IN_ARG (userNamePtr);
    
    return -1;
}

void TM_FAR * tfFSUserLogin(
    const char TM_FAR * userNamePtr,
    const char TM_FAR * passwordPtr)
{
    TM_UNREF_IN_ARG (userNamePtr);
    TM_UNREF_IN_ARG (passwordPtr);
    
    return (void TM_FAR *)0;
}

void tfFSUserLogout(
    void TM_FAR * userDataPtr)
{
    TM_UNREF_IN_ARG (userDataPtr);
    
    return;
}

int tfFSWriteFile(
    void TM_FAR * userDataPtr,
    void TM_FAR * fileDataPtr,
    const char TM_FAR * bufferPtr,
    int           bytes )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (fileDataPtr);
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (bytes);
    
    return -1;
}

int tfFSWriteFileRecord( 
    void TM_FAR * userDataPtr,
    void TM_FAR * fileDataPtr,
    char TM_FAR * bufferPtr,
    int           bytes,
    int           eor )
{
    TM_UNREF_IN_ARG (userDataPtr);
    TM_UNREF_IN_ARG (fileDataPtr);
    TM_UNREF_IN_ARG (bufferPtr);
    TM_UNREF_IN_ARG (bytes);
    TM_UNREF_IN_ARG (eor);
    
    return -1;
}

#endif /* TM_USE_TR_FS */

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:48      For: Xilinx-Samsung
 * File Name: trfs.c        File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 17462    Output checksum: 23659
 */
