/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description: testing the setsockopt and getsockopt
 *              functions for IPV4
 *
 * Filename: tu4opt.c
 * Author: Nicole Lu
 * Date Created:
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:49:07CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#include <trsocket.h>
/* The following 4 include's are for testing the internal API */
#include <trmacro.h>

#include <trtype.h>
#include <trproto.h>
#include <trglobal.h>

#include "tutest.h"

void tfx4SockOpt()
{
    int     setValue;
    int     getValue;   
    int     getLen;
    int     errorCode;


    int sd;
   
/* Create a socket */
    sd = socket(AF_INET, SOCK_DGRAM, IP_PROTOUDP);
    tm_assert(tfx4SockOpt, sd != TM_SOCKET_ERROR);

/* Set socket option */
    setValue = 8192;    
    errorCode = setsockopt(sd, SOL_SOCKET, TM_SO_RCV_DGRAMS, 
                           (char *) &setValue, sizeof(setValue));
    tm_assert(tfx4SockOpt, errorCode == TM_ENOERROR);

/* Get socket option with invalid option length */
    getLen = sizeof(char);
    errorCode = getsockopt(sd, SOL_SOCKET, TM_SO_RCV_DGRAMS,
                           (char *) &getValue, &getLen);
    tm_assert(tfx4SockOpt, errorCode == -1);
    errorCode  = tfGetSocketError(sd);
    tm_assert(tfx4SockOpt, errorCode == TM_EINVAL); 

    tfClose(sd);
}


/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:53      For: Xilinx-Samsung
 * File Name: tu4opt.c      File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 11920    Output checksum: 41884
 */
