/*
 * Copyright Notice:
 * Copyright Treck Incorporated  1997 - 2004
 * Copyright Elmic Systems Japan 1997 - 2004
 * No portions or the complete contents of this file may be copied or
 * distributed in any form (including but not limited to printed or electronic
 * forms) without the expressed written consent of Treck Incorporated OR
 * Elmic Systems.  Copyright laws and International Treaties protect the
 * contents of this file.  Unauthorized use is prohibited.
 * All rights reserved.
 *
 * Description : print out the errorno table
 * Filename : tuerrno.c
 * Author : Bryan Wang
 * Date Created : 04/23/2002
 * $Source: test/unittest/tuerrno.c $
 *
 * Modification History
 * $Revision: 6.0.2.2 $
 * $Date: 2010/01/18 06:49:29CST $
 * $Author: odile $
 * $ProjectName: /home/mks/proj/tcpip.pj $
 * $ProjectRevision: 6.0.1.23 $
 */

#include <trsocket.h>
#include <stdio.h>
void tfxPrintErrorCodeTable()
{
    printf("Treck Error Code Table\n\n");
	printf("TM_ERR_BASE       :%4d %8x\n",TM_ERR_BASE      , TM_ERR_BASE      );
	printf("TM_EPERM          :%4d %8x\n",TM_EPERM         , TM_EPERM         );
	printf("TM_ENOENT         :%4d %8x\n",TM_ENOENT        , TM_ENOENT        );
	printf("TM_ESRCH          :%4d %8x\n",TM_ESRCH         , TM_ESRCH         );
	printf("TM_EINTR          :%4d %8x\n",TM_EINTR         , TM_EINTR         );
	printf("TM_EIO            :%4d %8x\n",TM_EIO           , TM_EIO           );
	printf("TM_ENXIO          :%4d %8x\n",TM_ENXIO         , TM_ENXIO         );
	printf("TM_EBADF          :%4d %8x\n",TM_EBADF         , TM_EBADF         );
	printf("TM_ECHILD         :%4d %8x\n",TM_ECHILD        , TM_ECHILD        );
	printf("TM_ENOMEM         :%4d %8x\n",TM_ENOMEM        , TM_ENOMEM        );
	printf("TM_EACCES         :%4d %8x\n",TM_EACCES        , TM_EACCES        );
	printf("TM_EFAULT         :%4d %8x\n",TM_EFAULT        , TM_EFAULT        );
	printf("TM_EEXIST         :%4d %8x\n",TM_EEXIST        , TM_EEXIST        );
	printf("TM_ENODEV         :%4d %8x\n",TM_ENODEV        , TM_ENODEV        );
	printf("TM_ENOTDIR        :%4d %8x\n",TM_ENOTDIR       , TM_ENOTDIR       );
	printf("TM_EISDIR         :%4d %8x\n",TM_EISDIR        , TM_EISDIR        );
	printf("TM_EINVAL         :%4d %8x\n",TM_EINVAL        , TM_EINVAL        );
	printf("TM_EMFILE         :%4d %8x\n",TM_EMFILE        , TM_EMFILE        );
	printf("TM_ENOSPC         :%4d %8x\n",TM_ENOSPC        , TM_ENOSPC        );
	printf("TM_ERR_IO_LAST    :%4d %8x\n",TM_ERR_IO_LAST   , TM_ERR_IO_LAST   );
	printf("TM_EWOULDBLOCK    :%4d %8x\n",TM_EWOULDBLOCK   , TM_EWOULDBLOCK   );
	printf("TM_EAGAIN         :%4d %8x\n",TM_EAGAIN        , TM_EAGAIN        );
	printf("TM_EINPROGRESS    :%4d %8x\n",TM_EINPROGRESS   , TM_EINPROGRESS   );
	printf("TM_EALREADY       :%4d %8x\n",TM_EALREADY      , TM_EALREADY      );
	printf("TM_ENOTSOCK       :%4d %8x\n",TM_ENOTSOCK      , TM_ENOTSOCK      );
	printf("TM_EDESTADDRREQ   :%4d %8x\n",TM_EDESTADDRREQ  , TM_EDESTADDRREQ  );
	printf("TM_EMSGSIZE       :%4d %8x\n",TM_EMSGSIZE      , TM_EMSGSIZE      );
	printf("TM_EPROTOTYPE     :%4d %8x\n",TM_EPROTOTYPE    , TM_EPROTOTYPE    );
	printf("TM_ENOPROTOOPT    :%4d %8x\n",TM_ENOPROTOOPT   , TM_ENOPROTOOPT   );
	printf("TM_EPROTONOSUPPORT:%4d %8x\n",TM_EPROTONOSUPPORT, TM_EPROTONOSUPPORT);
	printf("TM_ESOCKTNOSUPPORT:%4d %8x\n",TM_ESOCKTNOSUPPORT, TM_ESOCKTNOSUPPORT);
	printf("TM_EOPNOTSUPP     :%4d %8x\n",TM_EOPNOTSUPP    , TM_EOPNOTSUPP    );
	printf("TM_EPFNOSUPPORT   :%4d %8x\n",TM_EPFNOSUPPORT  , TM_EPFNOSUPPORT  );
	printf("TM_EAFNOSUPPORT   :%4d %8x\n",TM_EAFNOSUPPORT  , TM_EAFNOSUPPORT  );
	printf("TM_EADDRINUSE     :%4d %8x\n",TM_EADDRINUSE    , TM_EADDRINUSE    );
	printf("TM_EADDRNOTAVAIL  :%4d %8x\n",TM_EADDRNOTAVAIL , TM_EADDRNOTAVAIL );
	printf("TM_ENETDOWN       :%4d %8x\n",TM_ENETDOWN      , TM_ENETDOWN      );
	printf("TM_ENETUNREACH    :%4d %8x\n",TM_ENETUNREACH   , TM_ENETUNREACH   );
	printf("TM_ENETRESET      :%4d %8x\n",TM_ENETRESET     , TM_ENETRESET     );
	printf("TM_ECONNABORTED   :%4d %8x\n",TM_ECONNABORTED  , TM_ECONNABORTED  );
	printf("TM_ECONNRESET     :%4d %8x\n",TM_ECONNRESET    , TM_ECONNRESET    );
	printf("TM_ENOBUFS        :%4d %8x\n",TM_ENOBUFS       , TM_ENOBUFS       );
	printf("TM_EISCONN        :%4d %8x\n",TM_EISCONN       , TM_EISCONN       );
	printf("TM_ENOTCONN       :%4d %8x\n",TM_ENOTCONN      , TM_ENOTCONN      );
	printf("TM_ESHUTDOWN      :%4d %8x\n",TM_ESHUTDOWN     , TM_ESHUTDOWN     );
	printf("TM_ETOOMANYREFS   :%4d %8x\n",TM_ETOOMANYREFS  , TM_ETOOMANYREFS  );
	printf("TM_ETIMEDOUT      :%4d %8x\n",TM_ETIMEDOUT     , TM_ETIMEDOUT     );
	printf("TM_ECONNREFUSED   :%4d %8x\n",TM_ECONNREFUSED  , TM_ECONNREFUSED  );
	printf("TM_EHOSTDOWN      :%4d %8x\n",TM_EHOSTDOWN     , TM_EHOSTDOWN     );
	printf("TM_EHOSTUNREACH   :%4d %8x\n",TM_EHOSTUNREACH  , TM_EHOSTUNREACH  );
	printf("TM_ERR_BASE_LAST  :%4d %8x\n",TM_ERR_BASE_LAST , TM_ERR_BASE_LAST );
	printf("TM_SOCKET_ERROR   :%4d %8x\n",TM_SOCKET_ERROR  , TM_SOCKET_ERROR  );
	printf("TM_ENOERROR       :%4d %8x\n",TM_ENOERROR      , TM_ENOERROR      );
    printf("end of table\n\n");
}

/* Processed by Treck Shipping Tool v2.60 
 * 2012/02/06 10:46:53      For: Xilinx-Samsung
 * File Name: tuerrno.c     File Revision: 6.0.2.2 
 * Project Name: tcpip.pj   Project Release: 6.0.1.23
 * Input checksum: 18971    Output checksum: 37427
 */
