/* $Id: */
/********************************************************************
 * Copyright(C) 2008 by Xilinx, Inc. All rights reserved.
 * This text/file contains proprietary, confidential
 * information of Xilinx, Inc., is distributed under license
 * from Xilinx, Inc., and may be used, copied and/or
 * disclosed only pursuant to the terms of a valid license
 * agreement with Xilinx, Inc.  Xilinx hereby grants you a
 * license to use this text/file solely for design, simulation,
 * implementation and creation of design files limited
 * to Xilinx devices or technologies. Use with non-Xilinx
 * devices or technologies is expressly prohibited and
 * immediately terminates your license unless covered by
 * a separate agreement.
 *
 * Xilinx is providing this design, code, or information
 * as-is solely for use in developing programs and
 * solutions for Xilinx devices, with no obligation on the
 * part of Xilinx to provide support.  By providing this design,
 * code, or information as one possible implementation of
 * this feature, application or standard, Xilinx is making no
 * representation that this implementation is free from any
 * claims of infringement.  You are responsible for
 * obtaining any rights you may require for your implementation.
 * Xilinx expressly disclaims any warranty whatsoever with
 * respect to the adequacy of the implementation, including
 * but not limited to any warranties or representations that this
 * implementation is free from claims of infringement, implied
 * warranties of merchantability or fitness for a particular
 * purpose.
 *
 * Xilinx products are not intended for use in life support
 * appliances, devices, or systems. Use in such applications is
 * expressly prohibited.
 *
 * Any modifications that are made to the Source Code are
 * done at the user's sole risk and will be unsupported.
 * The Xilinx Support Hotline does not have access to source
 * code and therefore cannot answer specific questions related
 * to source HDL.
 *
 * This copyright and support notice must be retained as part
 * of this text at all times.
 * (c) Copyright 2008 Xilinx, Inc.
 * All rights reserved.
 ********************************************************************/

/******************************************************************************
*
* app.h - Declarations for the applications
*
* MODIFICATION HISTORY:
*
* Ver   Who  Date     Changes
* ----- ---- -------- -----------------------------------------------
* 1     drg  03/31/08 First release
*
*****************************************************************************/

/***************************** Include Files ********************************/
#include "trsocket.h"
#include "trmacro.h"

/************************** Constant Definitions ****************************/

/**************************** Type Definitions ******************************/

/***************** Macros (Inline Functions) Definitions ********************/

/************************** Function Prototypes *****************************/
#ifdef TM_TRECK_NO_KERNEL
int AppInitTreck();
int AppAddInterface();
int AppOpenInterface();
void PollIO();
ttUserInterface Treck_CreateInterface();
#else /* TM_TRECK_NO_KERNEL */
int Interface_Reset(ttUserInterface interfaceHandle);
#endif /* TM_TRECK_NO_KERNEL */

int AppLoopbackTests(unsigned MenuIndex, unsigned TestLoops);

int AppTxTcpMainSimple(unsigned MenuIndex, unsigned TestLoops);
int AppTxTcpMainCallbacks(unsigned MenuIndex, unsigned TestLoops);
int AppTxUdpMainWithoutConnection(unsigned MenuIndex, unsigned TestLoops);

int AppRxTcpMain(unsigned MenuIndex, unsigned TestLoops);
int AppRxUdpMain(unsigned MenuIndex, unsigned TestLoops);

#ifdef TM_USE_HTTPD
int AppHttpServerToggle(unsigned MenuIndex, unsigned TestLoops);
#endif /* TM_USE_HTTPD */

#ifdef TM_USE_FTPD
int AppFtpServerToggle(unsigned MenuIndex, unsigned TestLoops);
#endif /*TM_USE_FTPD */

#ifdef TM_USE_TELNETD
int AppTelnetServerToggle(unsigned MenuIndex, unsigned TestLoops);
#endif /* TM_USE_TELNETD */

#ifdef TM_SNMP_VERSION
int AppSnmpServerToggle(unsigned MenuIndex, unsigned TestLoops);
#endif /* TM_SNMP_VERSION */

void treck_test_ping_loopback(ttUserInterface interfaceHandle);
void treck_test_tcp_loopback(void);
void treck_test_udp_loopback(void);

/*****************************************************************************
 *                    Utility Menu Functions
 ******************************************************************************/
int Util_Csum(unsigned MenuIndex, unsigned TestLoops);
int Util_Addr(unsigned MenuIndex, unsigned TestLoops);
int Util_DestAddr(unsigned MenuIndex, unsigned TestLoops);
int Util_Port(unsigned MenuIndex, unsigned TestLoops);
int Util_Mtu(unsigned MenuIndex, unsigned TestLoops);
int Util_Coalesc(unsigned MenuIndex, unsigned TestLoops);
int Util_TxTestFileSize(unsigned MenuIndex, unsigned TestLoops);
int Util_SockSize(unsigned MenuIndex, unsigned TestLoops);
int Util_CloseOpen(unsigned MenuIndex, unsigned TestLoops);
int Util_SetSpeed(unsigned MenuIndex, unsigned TestLoops);
int AppUtil_DumpStats();

/************************** Variable Definitions ****************************/
