/* $Id: */
/********************************************************************
 * Copyright(C) 2008 by Xilinx, Inc. All rights reserved.
 * This text/file contains proprietary, confidential
 * information of Xilinx, Inc., is distributed under license
 * from Xilinx, Inc., and may be used, copied and/or
 * disclosed only pursuant to the terms of a valid license
 * agreement with Xilinx, Inc.  Xilinx hereby grants you a
 * license to use this text/file solely for design, simulation,
 * implementation and creation of design files limited
 * to Xilinx devices or technologies. Use with non-Xilinx
 * devices or technologies is expressly prohibited and
 * immediately terminates your license unless covered by
 * a separate agreement.
 *
 * Xilinx is providing this design, code, or information
 * as-is solely for use in developing programs and
 * solutions for Xilinx devices, with no obligation on the
 * part of Xilinx to provide support.  By providing this design,
 * code, or information as one possible implementation of
 * this feature, application or standard, Xilinx is making no
 * representation that this implementation is free from any
 * claims of infringement.  You are responsible for
 * obtaining any rights you may require for your implementation.
 * Xilinx expressly disclaims any warranty whatsoever with
 * respect to the adequacy of the implementation, including
 * but not limited to any warranties or representations that this
 * implementation is free from claims of infringement, implied
 * warranties of merchantability or fitness for a particular
 * purpose.
 *
 * Xilinx products are not intended for use in life support
 * appliances, devices, or systems. Use in such applications is
 * expressly prohibited.
 *
 * Any modifications that are made to the Source Code are
 * done at the user's sole risk and will be unsupported.
 * The Xilinx Support Hotline does not have access to source
 * code and therefore cannot answer specific questions related
 * to source HDL.
 *
 * This copyright and support notice must be retained as part
 * of this text at all times.
 * (c) Copyright 2008 Xilinx, Inc.
 * All rights reserved.
 ********************************************************************/

/******************************************************************************
*
* debug.h - Debug output macro definition
*
* MODIFICATION HISTORY:
*
* Ver   Who  Date     Changes
* ----- ---- -------- -----------------------------------------------
* 1     drg  04/03/08 First release
*
*****************************************************************************/

#ifndef _DEBUG_H_ /* prevent circular inclusions */
#define _DEBUG_H_ /* by using protection macros */

/***************************** Include Files ********************************/
#include <stdlib.h>

/************************** Constant Definitions ****************************/
#undef  TDEBUG                    /* Define this to enable debugging code */
//#define TDEBUG

#define DEBUG_ERROR     0x0001    /* all error conditions */
#define DEBUG_TX        0x0002    /* tx routines */
#define DEBUG_RX        0x0004    /* rx routines */
#define DEBUG_APP       0x0008    /* Application routines */
#define DEBUG_MISC      0x0010    /* other routines */
#define DEBUG_MEM       0x0020    /* Memory routines */
#define DEBUG_ALL       0xFFFF    /* all debugging data */

/***************** Macros (Inline Functions) Definitions ********************/
#ifdef TDEBUG
#  warning TDEBUG is active
#  define DEBUG_LOG(FLAG, fmt, args...) \
    if (tdebug & (FLAG)) xil_printf(fmt "\r\n", ## args)

extern int tdebug;  /* Use the flag in debug.h to define which debugs
                              outputs to send*/
#else
#  define DEBUG_LOG(FLAG, fmt, args...)
#endif

//#define MSG(fmt, args...) xil_printf(fmt "\r\n", ## args)

/************************** Variable Definitions ****************************/
#endif /* _DEBUG_H_ */
