/* $Id: */
/********************************************************************
 * Copyright(C) 2008 by Xilinx, Inc. All rights reserved.
 * This text/file contains proprietary, confidential
 * information of Xilinx, Inc., is distributed under license
 * from Xilinx, Inc., and may be used, copied and/or
 * disclosed only pursuant to the terms of a valid license
 * agreement with Xilinx, Inc.  Xilinx hereby grants you a
 * license to use this text/file solely for design, simulation,
 * implementation and creation of design files limited
 * to Xilinx devices or technologies. Use with non-Xilinx
 * devices or technologies is expressly prohibited and
 * immediately terminates your license unless covered by
 * a separate agreement.
 *
 * Xilinx is providing this design, code, or information
 * as-is solely for use in developing programs and
 * solutions for Xilinx devices, with no obligation on the
 * part of Xilinx to provide support.  By providing this design,
 * code, or information as one possible implementation of
 * this feature, application or standard, Xilinx is making no
 * representation that this implementation is free from any
 * claims of infringement.  You are responsible for
 * obtaining any rights you may require for your implementation.
 * Xilinx expressly disclaims any warranty whatsoever with
 * respect to the adequacy of the implementation, including
 * but not limited to any warranties or representations that this
 * implementation is free from claims of infringement, implied
 * warranties of merchantability or fitness for a particular
 * purpose.
 *
 * Xilinx products are not intended for use in life support
 * appliances, devices, or systems. Use in such applications is
 * expressly prohibited.
 *
 * Any modifications that are made to the Source Code are
 * done at the user's sole risk and will be unsupported.
 * The Xilinx Support Hotline does not have access to source
 * code and therefore cannot answer specific questions related
 * to source HDL.
 *
 * This copyright and support notice must be retained as part
 * of this text at all times.
 * (c) Copyright 2008 Xilinx, Inc.
 * All rights reserved.
 ********************************************************************/

/******************************************************************************
*
* defaults.h - Any and hopefully all of the default values used should be set
* here.
*
* MODIFICATION HISTORY:
*
* Ver   Who  Date     Changes
* ----- ---- -------- -----------------------------------------------
* 1     drg  03/31/08 First release
*
*****************************************************************************/
#ifndef _TR_DEFAULTS_H_
#define _TR_EFAULTS_H_

/***************************** Include Files ********************************/

/************************* Settings Menu defaults ***************************/
/* These values control the defaults for options that can be set in the
 * settings menu from the application.  Change these values to make them
 * the default settings for the application so they don't have to be set
 * every time it is run.
 */
/* set IP address */
#define DEFAULT_IP_ADDR "192.168.1.20"
#define DEFAULT_NETMASK "255.255.255.0"
#define DEFAULT_GATEWAY "192.168.1.1"

/* Set iPerf Address */
#define DEFAULT_SERVER  "192.168.1.1"

/* Set PHY Address (0-31) */
#define DEFAULT_PHY_ADDR    7

/* Set Network MTU (1500 or 9000) */
#define DEFAULT_MTU    1500

/* Set TX Test File Size (in MB) */
#define DEFAULT_TEST_FILE_SIZE_MB    10240
/*
 * Not yet a menu option:
 * Size in gigabytes of amount of receive data before the demo's
 * RX servers close the connection/stop listening
 */
#define DEFAULT_RX_GIGABYTE_CUTOFF 3

/* Set TCP Port */
#define DEFAULT_TCP_PORT 5001

/************************** Constant Definitions ****************************/
/* Unlike the macros above, changing these defaults requires careful study
 * of the code.  Don't change these unless you know what you are doing*/

/* Thread priorities for Xilkernel */
#define TIMER_THREAD_PRIO    1
#define RX_THREAD_PRIO       2
#define MAIN_THREAD_PRIO     5
#define FTP_THREAD_PRIO      5
#define HTTP_THREAD_PRIO     5
#define TELNET_THREAD_PRIO   5
#define SNMP_THREAD_PRIO     5
#define FREE_TX_THREAD_PRIO  10

#define TICK_INTERVAL_MS    100

#define RX_BD_COUNT    512
#define TX_BD_COUNT    512

#define DEFAULT_MACADDR 0x00,0x0A,0x35,0x01,0x93,0xEB

#define RX_SCAT_BUF_LEN    512

/* Really 18, but add 2 to align the ethernet header */
#define ETHER_HEADER_SIZE    20

#define DEFAULT_RX_TIMEOUT      25
#define DEFAULT_RX_THRESHOLD    1
#define DEFAULT_TX_TIMEOUT      25
#define DEFAULT_TX_THRESHOLD    1

/* Time to wait for the PHY to settle */
#define INIT_DELAY_MSEC    2000

/* Length of IP addr string, XXX.XXX.XXX.XXX */
#define IP_ADDR_LEN    16
/* Length of input string */
#define IN_BUF_LEN    10

#define APP_BUF_SIZE    (512 * 1024)

#define TRECK_USE_SIMPLE_DMA    0
#define TRECK_USE_SCAT_GATHER    1

#define MAX_FRAG_BUFS    5

/**************************** Type Definitions ******************************/

/***************** Macros (Inline Functions) Definitions ********************/
#define ROUND_UP(x, align)      (((int) (x) + (align - 1)) & ~(align - 1))

/************************** Function Prototypes *****************************/

/************************** Variable Definitions ****************************/
#endif /*_TR_DEFAULTS_H_ */
