/* $Id: */
/********************************************************************
 * Copyright(C) 2003 by Xilinx, Inc. All rights reserved.
 * This text/file contains proprietary, confidential
 * information of Xilinx, Inc., is distributed under license
 * from Xilinx, Inc., and may be used, copied and/or
 * disclosed only pursuant to the terms of a valid license
 * agreement with Xilinx, Inc.  Xilinx hereby grants you a
 * license to use this text/file solely for design, simulation,
 * implementation and creation of design files limited
 * to Xilinx devices or technologies. Use with non-Xilinx
 * devices or technologies is expressly prohibited and
 * immediately terminates your license unless covered by
 * a separate agreement.
 *
 * Xilinx is providing this design, code, or information
 * as-is solely for use in developing programs and
 * solutions for Xilinx devices, with no obligation on the
 * part of Xilinx to provide support.  By providing this design,
 * code, or information as one possible implementation of
 * this feature, application or standard, Xilinx is making no
 * representation that this implementation is free from any
 * claims of infringement.  You are responsible for
 * obtaining any rights you may require for your implementation.
 * Xilinx expressly disclaims any warranty whatsoever with
 * respect to the adequacy of the implementation, including
 * but not limited to any warranties or representations that this
 * implementation is free from claims of infringement, implied
 * warranties of merchantability or fitness for a particular
 * purpose.
 *
 * Xilinx products are not intended for use in life support
 * appliances, devices, or systems. Use in such applications is
 * expressly prohibited.
 *
 * Any modifications that are made to the Source Code are
 * done at the user's sole risk and will be unsupported.
 * The Xilinx Support Hotline does not have access to source
 * code and therefore cannot answer specific questions related
 * to source HDL.
 *
 * This copyright and support notice must be retained as part
 * of this text at all times. (c) Copyright 2008 Xilinx, Inc.
 * All rights reserved.
 ********************************************************************/

/******************************************************************************
*
* ping_loopback_test.c
*
* MODIFICATION HISTORY:
*
* Ver   Who  Date     Changes
* ----- ---- -------- -----------------------------------------------
* 1
*
*****************************************************************************/

/***************************** Include Files ********************************/
#include <stdio.h>
#include "loopback.h"
#include "util_time.h"

/************************** Constant Definitions ****************************/

/**************************** Type Definitions ******************************/

/***************** Macros (Inline Functions) Definitions ********************/

/************************** Variable Definitions ****************************/

/************************** Function Prototypes *****************************/
void tfxPingCallBack (int PingSd);


/****************************************************************************
 * expecting <interface name> <our address> <peer address>
 ****************************************************************************/
void treck_test_ping_loopback(ttUserInterface interfaceHandle)
{
    int             pingSd;
    int             i;

    pingSd = tfPingOpenStart(
                "192.168.2.1",//"127.0.0.1",
                1, /* 1 second between retransmissions */
                100, /* 100 bytes of data */
                (ttPingCBFuncPtr) tfxPingCallBack);

    if (pingSd == TM_SOCKET_ERROR)
    {
        xil_printf("Failed to start ping! - %s\r\n", tfStrError(tfGetSocketError(pingSd)));
    }
/* let the ping proceed for a few seconds */
#ifdef TM_TRECK_NO_KERNEL
    for (i = 0; i < 10; i++)
    {
#ifdef __PPC__
        sleep(1);
#else
        usleepWithRecvInterface(1000*1000, interfaceHandle);
#endif /* __PPC__ */
        tfTimerExecute();
    }
#else
    for (i = 0; i < 50; i++)
    {
        sleep(100);
    }
#endif /* TM_TRECK_NO_KERNEL*/
    tfPingClose(pingSd);
}

void tfxPingCallBack(int pingSd)
{
    ttPingInfo pingInfo;

    tfPingGetStatistics(pingSd, &pingInfo);
    xil_printf("ping=%d pong=%d; ttl=%dms\r\n",
            pingInfo.pgiTransmitted,
            pingInfo.pgiReceived,
            pingInfo.pgiLastRtt);
}
