    /* $Id: */
/********************************************************************
 * Copyright(C) 2008 by Xilinx, Inc. All rights reserved.
 * This text/file contains proprietary, confidential
 * information of Xilinx, Inc., is distributed under license
 * from Xilinx, Inc., and may be used, copied and/or
 * disclosed only pursuant to the terms of a valid license
 * agreement with Xilinx, Inc.  Xilinx hereby grants you a
 * license to use this text/file solely for design, simulation,
 * implementation and creation of design files limited
 * to Xilinx devices or technologies. Use with non-Xilinx
 * devices or technologies is expressly prohibited and
 * immediately terminates your license unless covered by
 * a separate agreement.
 *
 * Xilinx is providing this design, code, or information
 * as-is solely for use in developing programs and
 * solutions for Xilinx devices, with no obligation on the
 * part of Xilinx to provide support.  By providing this design,
 * code, or information as one possible implementation of
 * this feature, application or standard, Xilinx is making no
 * representation that this implementation is free from any
 * claims of infringement.  You are responsible for
 * obtaining any rights you may require for your implementation.
 * Xilinx expressly disclaims any warranty whatsoever with
 * respect to the adequacy of the implementation, including
 * but not limited to any warranties or representations that this
 * implementation is free from claims of infringement, implied
 * warranties of merchantability or fitness for a particular
 * purpose.
 *
 * Xilinx products are not intended for use in life support
 * appliances, devices, or systems. Use in such applications is
 * expressly prohibited.
 *
 * Any modifications that are made to the Source Code are
 * done at the user's sole risk and will be unsupported.
 * The Xilinx Support Hotline does not have access to source
 * code and therefore cannot answer specific questions related
 * to source HDL.
 *
 * This copyright and support notice must be retained as part
 * of this text at all times.
 * (c) Copyright 2008 Xilinx, Inc.
 * All rights reserved.
 ********************************************************************/

/******************************************************************************
*
* treck_dma.h - Include file for the treck stack to DMA interface.
*
* MODIFICATION HISTORY:
*
* Ver   Who  Date     Changes
* ----- ---- -------- -----------------------------------------------
* 1     drg  03/31/08 First release
* 2     pdmc 03/10/11 Modified for AXI bus
*
*****************************************************************************/

/***************************** Include Files ********************************/
#include "xtr_axiethernet.h"
/* Included in /\
#include <trsocket.h>
#include "xlltemac.h"
#include "xlldma.h"
 */

/************************** Constant Definitions ****************************/

/**************************** Type Definitions ******************************/

/***************** Macros (Inline Functions) Definitions ********************/

/************************** Function Prototypes *****************************/
int InitializeDmaAndEthernet(TemacDevData * Mac);

int AxiDma_Setup(TemacDevData * Mac);

/* Functions used by the Treck interface */
int AxiDma_Open(ttUserInterface Handle);

int AxiDma_Send(ttUserInterface Handle, ttUserPacketPtr PktPtr);

int AxiDma_Recv(ttUserInterface Handle, char TM_FAR** DataPtr,
                  int TM_FAR* DataLen, ttUserBufferPtr BufHandle,
                  ttDevRecvOffloadPtr Csum);

int AxiDma_Close(ttUserInterface Handle);

int AxiDma_Ioctl(ttUserInterface Handle, int Flag, void TM_FAR* OptionPtr,
                 int OptionLen);

int AxiDma_RefillRxRing(ttUserInterface Handle);

int AxiDma_BufFree(ttUserInterface Handle, char TM_FAR *dataPtr);

int DmaUtil_DumpStats(XAxiDma* DmaInst);

/* Scatter Gather functions in xtr_scatdma.c */
int AxiDma_ScatOpen(ttUserInterface Handle);

int AxiDma_ScatSend(ttUserInterface Handle, ttUserPacketPtr PktPtr);

void SgRxISR(void *Callback);


/************************** Variable Definitions ****************************/
